dsa-check-running-kernel: sort kernel versions better
[mirror/dsa-nagios.git] / dsa-nagios-checks / checks / dsa-check-running-kernel
1 #!/bin/bash
2
3 # Check if the running kernel has the same version string as the on-disk
4 # kernel image.
5
6 # Copyright 2008,2009,2011,2012,2013,2014 Peter Palfrader
7 # Copyright 2009 Stephen Gran
8 # Copyright 2010,2012,2013 Uli Martens
9 # Copyright 2011 Alexander Reichle-Schmehl
10 #
11 # Permission is hereby granted, free of charge, to any person obtaining
12 # a copy of this software and associated documentation files (the
13 # "Software"), to deal in the Software without restriction, including
14 # without limitation the rights to use, copy, modify, merge, publish,
15 # distribute, sublicense, and/or sell copies of the Software, and to
16 # permit persons to whom the Software is furnished to do so, subject to
17 # the following conditions:
18 #
19 # The above copyright notice and this permission notice shall be
20 # included in all copies or substantial portions of the Software.
21 #
22 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
23 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
24 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
25 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
26 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
27 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
28 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
29
30 OK=0;
31 WARNING=1;
32 CRITICAL=2;
33 UNKNOWN=3;
34
35 get_offset() {
36         local file needle
37
38         file="$1"
39         needle="$2"
40
41         perl -e '
42                 undef $/;
43                 $i = 0; $k=<>;
44                 while (($i = index($k, "'"$needle"'", $i)) >= 0) {
45                         print $i++,"\n";
46                 }; ' < "$file"
47 }
48
49 get_avail() {
50         # This is wrong, but leaves room for when we have to care for machines running
51         # myfirstunix-image-0.1-dsa-arm
52         local prefix="$1"; shift
53
54         local kervers=$(uname -r)
55
56         local metavers=''
57
58         # DSA uses kernel versions of the form 2.6.29.3-dsa-dl380-oldxeon, where
59         # Debian uses versions of the form 2.6.29-2-amd64
60         if [ "${kervers#2}" != "$kervers" ]; then
61                 if [ "${kervers//dsa}" != "$kervers" ]; then
62                         metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+([\.0-9]+?)-(.*)/2.\1-\3/')
63                 else
64                         metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+-[A-Za-z0-9\.]+-(.*)/2.\1-\2/')
65                 fi
66         else
67                 metavers=$(echo $kervers | sed -r -e 's/^[0-9]+\.[0-9]+(\.[0-9])?+-[A-Za-z0-9\.]+-(.*)/\2/')
68         fi
69
70         # Attempt to track back to a metapackage failed.  bail
71         if [ "$metavers" = "$kervers" ]; then
72                 return 2
73         fi
74
75         # We're just going to give up if we can't find a matching metapackage
76         # I tried being strict once, and it just caused a lot of headaches.  We'll see how
77         # being lax does for us
78
79         local output=$(apt-cache policy ${prefix}-image-${metavers} 2>/dev/null)
80         local metaavailvers=$(echo "$output" | grep '^  Candidate:' | awk '{print $2}')
81         local metainstavers=$(echo "$output" | grep '^  Installed:' | awk '{print $2}')
82
83         if [ -z "$metaavailvers" ] || [ "$metaavailvers" = '(none)' ]; then
84                 return 2
85         fi
86         if [ -z "$metainstavers" ] || [ "$metainstavers" = '(none)' ]; then
87                 return 2
88         fi
89
90         if [ "$metaavailvers" != "$metainstavers" ] ; then
91                 echo "${prefix}-image-${metavers} $metaavailvers available but $metainstavers installed"
92                 return 1
93         fi
94
95         local imagename=0
96         # --no-all-versions show shows only the candidate
97         for vers in $(apt-cache --no-all-versions show ${prefix}-image-${metavers} | sed -n 's/^Depends: //p' | tr ',' '\n' | tr -d ' ' | grep ${prefix}-image | awk '{print $1}' | sort -Vu); do
98                 if dpkg --compare-versions "1.$vers" gt "1.$imagename"; then
99                         imagename=$vers
100                 fi
101         done
102
103         if [ -z "$imagename" ] || [ "$imagename" = 0 ]; then
104                 return 2
105         fi
106
107         if [ "$imagename" != "${prefix}-image-${kervers}" ]; then
108                 if dpkg --compare-versions 1."$imagename" lt 1."${prefix}-image-${kervers}"; then
109                         return 2
110                 fi
111                 echo "$imagename" != "${prefix}-image-${kervers}"
112                 return 1
113         fi
114
115         local availvrs=$(apt-cache policy ${imagename} 2>/dev/null | grep '^  Candidate' | awk '{print $2}')
116         local kernelversion
117         for kernelversion in $(apt-cache policy ${prefix}-image-${kervers} ${prefix}-image-${kervers}-unsigned 2>/dev/null | grep '^  Installed:' | awk '{print $2}' | grep -F -v '(none)' ); do
118                 if [ "$availvrs" = "$kernelversion" ]; then
119                         return 0
120                 fi
121         done
122
123         echo "$kernelversion != $availvrs"
124         return 1
125 }
126
127 cat_vmlinux() {
128         local image header filter hdroff
129
130         image="$1"
131         header="$2"
132         filter="$3"
133         hdroff="$4"
134
135         get_offset "$image" $header | head -n 5 | while read off; do
136                 (if [ "$off" != 0 ]; then
137                    dd ibs="$((off+hdroff))" skip=1 count=0
138                  fi &&
139                  dd bs=512k) < "$image"  2>/dev/null | $filter 2>/dev/null
140         done
141 }
142
143 get_image_linux() {
144         local image
145
146         image="$1"
147
148         # gzip compressed image
149         cat_vmlinux "$image" "\x1f\x8b\x08\x00"      "zcat"   0
150         cat_vmlinux "$image" "\x1f\x8b\x08\x08"      "zcat"   0
151         # lzma compressed image
152         cat_vmlinux "$image" "\x00\x00\x00\x02\xff"  "xzcat" -1
153         cat_vmlinux "$image" "\x00\x00\x00\x04\xff"  "xzcat" -1
154         # xz compressed image
155         cat_vmlinux "$image" "\xfd\x37\x7a\x58\x5a " "xzcat"  0
156
157         echo "ERROR: Unable to extract kernel image." 2>&1
158         exit 1
159 }
160
161
162 freebsd_check_running_version() {
163         local imagefile="$1"; shift
164
165         local r="$(uname -r)"
166         local v="$(uname -v| sed -e 's/^#[0-9]*/&:/')"
167
168         local q='@(#)FreeBSD '"$r $v"
169
170         if zcat "$imagefile" | $STRINGS | grep -F -q "$q"; then
171                 echo "OK"
172         else
173                 echo "not OK"
174         fi
175 }
176
177 STRINGS="";
178 if [ -x "$(which strings)" ]; then
179         STRINGS="$(which strings)"
180 elif [ -x "$(which busybox)" -a "$( echo foobar | $(which busybox) strings 2>/dev/null)" = "foobar" ]; then
181         STRINGS="$(which busybox) strings"
182 fi
183
184 searched=""
185 for on_disk in \
186         "/boot/vmlinuz-`uname -r`"\
187         "/boot/vmlinux-`uname -r`"\
188         "/boot/kfreebsd-`uname -r`.gz"; do
189
190         if [ -e "$on_disk" ]; then
191                 if [ -z "$STRINGS" ]; then
192                         echo "UNKNOWN: 'strings' command missing, perhaps install binutils or busybox?"
193                         exit $UNKNOWN
194                 fi
195                 if [ "${on_disk/vmlinu}" != "$on_disk" ]; then
196                         on_disk_version="`get_image_linux "$on_disk" | $STRINGS | grep 'Linux version' | head -n1`"
197                         if [ -x /usr/bin/lsb_release ] ; then
198                                 vendor=$(lsb_release -i -s)
199                                 if [ -n "$vendor" ] && [ "xDebian" != "x$vendor" ] ; then
200                                         on_disk_version=$( echo $on_disk_version|sed -e "s/ ($vendor [[:alnum:]\.-]\+ [[:alnum:]\.]\+)//")
201                                 fi
202                         fi
203                         [ -z "$on_disk_version" ] || break
204                         on_disk_version="`cat "$on_disk" | $STRINGS | grep 'Linux version' | head -n1`"
205                         [ -z "$on_disk_version" ] || break
206
207                         echo "UNKNOWN: Failed to get a version string from image $on_disk"
208                         exit $UNKNOWN
209                 else
210                         on_disk_version="$(zcat $on_disk | $STRINGS | grep Debian | head -n 1 | sed -e 's/Debian [[:alnum:]]\+ (\(.*\))/\1/')"
211                 fi
212         fi
213         searched="$searched $on_disk"
214 done
215
216 if ! [ -e "$on_disk" ]; then
217         echo "WARNING: Did not find a kernel image (checked$searched) - I have no idea which kernel I am running"
218         exit $WARNING
219 fi
220
221 if [ "$(uname -s)" = "Linux" ]; then
222         running_version="`cat /proc/version`"
223         if [ -z "$running_version" ] ; then
224                 echo "UNKNOWN: Failed to get a version string from running system"
225                 exit $UNKNOWN
226         fi
227
228         if [ "$running_version" != "$on_disk_version" ]; then
229                 echo "WARNING: Running kernel does not match on-disk kernel image: [$running_version != $on_disk_version]"
230                 exit $WARNING
231         fi
232
233         ret="$(get_avail linux)"
234         if [ $? = 1 ]; then
235                 echo "WARNING: Kernel needs upgrade [$ret]"
236                 exit $WARNING
237         fi
238 else
239         image_current=$(freebsd_check_running_version $on_disk)
240         running_version="`uname -s` `uname -r` `uname -v`"
241         if [ "$image_current" != "OK" ]; then
242                 approx_time="$(date -d "@`stat -c '%Y' "$on_disk"`" +"%Y-%m-%d %H:%M:%S")"
243                 echo "WARNING: Currently running kernel ($running_version) does not match on disk image (~ $approx_time)"
244                 exit $WARNING;
245         fi
246
247         ret="$(get_avail linux)"
248         if [ $? = 1 ]; then
249                 echo "WARNING: Kernel needs upgrade [$ret]"
250                 exit $WARNING
251         fi
252 fi
253
254 echo "OK: Running kernel matches on disk image: [$running_version]"
255 exit $OK